<?php

namespace Osinet\DemoBundle\DependencyInjection;

use Osinet\DemoBundle\Controller\DemoController;
use Symfony\Component\Config\FileLocator;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Loader\YamlFileLoader;
use Symfony\Component\HttpKernel\DependencyInjection\ConfigurableExtension;

class OsinetDemoExtension extends ConfigurableExtension {
  // Autogenerated by SF4: we define it too in order to have a reference point.
  const ALIAS = 'osinet_demo';

  // Service aliases, for reference during refactors.
  const S_DEMO = self::ALIAS . '.democode';

  /**
   * Delegate configuration loading to a loader.
   *
   * @param \Symfony\Component\DependencyInjection\ContainerBuilder $container
   */
  protected function doLoad(ContainerBuilder $container) {
    $loader = new YamlFileLoader(
      $container,
      new FileLocator(__DIR__ . '/../Resources/config')
    );
    $loader->load('services.yml');
  }

  /**
   * {@inheritdoc}
   */
  protected function loadInternal(array $mergedConfig, ContainerBuilder $container) {
    $this->doLoad($container);
    $this->override($mergedConfig, $container);
    $this->hintAnnotations();
  }

  /**
   * Apply the "friendly" configuration to override the bundle.
   *
   * @param array $mergedConfig
   * @param \Symfony\Component\DependencyInjection\ContainerBuilder $container
   */
  protected function override(array $mergedConfig, ContainerBuilder $container) {
    $def = $container->getDefinition(static::S_DEMO);
    $overridden = '$codeMessage';
    $def->replaceArgument($overridden, $mergedConfig['prefix'] . ' ' . $def->getArgument($overridden));
  }

  /**
   * Help build a faster container by specifying whence to parse annotations.
   */
  protected function hintAnnotations() {
    $this->addAnnotatedClassesToCompile([
      DemoController::class,
    ]);
  }
}
