<?php

namespace Osinet\DemoBundle\Tests\Command;


use Osinet\DemoBundle\Command\DemoCommand;
use Osinet\DemoBundle\Lucky;
use Symfony\Bundle\FrameworkBundle\Console\Application;
use Symfony\Bundle\FrameworkBundle\Test\KernelTestCase;
use Symfony\Component\Console\Tester\CommandTester;

class DemoCommandTest extends KernelTestCase {

  /**
   * @var \Psr\Container\ContainerInterface
   */
  protected $dic;

  /**
   * @var \Symfony\Component\Console\Tester\CommandTester
   */
  protected $tester;

  protected function setUp() {
    $kernel = self::bootKernel();
    $this->dic = $kernel->getContainer();
    $app = new Application($kernel);
    $app->add($this->dic->get(DemoCommand::class));
    $command = $app->find(DemoCommand::NAME);
    $this->tester = new CommandTester($command);
  }

  public function testExecuteExplicit() {
    $expected = 42;
    $this->tester->execute(['--' . DemoCommand::O_LUCKY => $expected]);
    $output = $this->tester->getDisplay();
    $this->assertRegexp('/^[\d]+\n$/', $output);
    $actual = (int) $output;
    $this->assertEquals($expected, $actual);
  }

  public function testExecuteImplicit() {
    $this->tester->execute([]);
    $output = $this->tester->getDisplay();
    $this->assertRegexp('/^[\d]+\n$/', $output);
    $actual = (int) $output;
    $this->assertTrue($actual <= 100);
  }
}
